﻿function AnalyticsController() {
    BaseController.call(this, "Analytics");
}

AnalyticsController.prototype = Object.create(BaseController.prototype);
AnalyticsController.prototype.constructor = AnalyticsController;
App.RegisterController(AnalyticsController);

AnalyticsController.prototype.Initialize = function (callback) {
    $(".main").on("pageshow", App.Analytics.ProcessPageShow);
    BaseController.prototype.Initialize.call(App.Analytics, callback);
}

AnalyticsController.prototype.ProcessPageShow = function (e) {
    try {
        var id = e.currentTarget.id;
        if (App.Analytics.IsIgnoredPage(id)) return;
        var url = "/Mobile/" + id;
        var urlparams = App.Analytics.GetPageURLParams(id);
        if (urlparams && urlparams != "") {
            url += "/" + urlparams;
        }
        var params = App.Analytics.GetPageParams(id);
        if (params && params != "") {
            url += "?" + params;
        }
        _gaq.push(['_trackPageview', url]);
        App.Analytics.PageShowPostProcessing(id);
    }
    catch (ex) { }
}

AnalyticsController.prototype.IsIgnoredPage = function (id) {
    if (id == "AppLoading") return true;
    return false;
}

AnalyticsController.prototype.GetPageParams = function (id) {
    switch (id) {
        case "BuscarIndex":
            return $.param(App.Buscar.GetCurrentSearchParams());
    }
    return "";
}

AnalyticsController.prototype.GetPageURLParams = function (id) {
    switch (id) {
        case "DeliveryIndex":
            return App.Delivery.Current.ID;
        case "DeliveryAgregar":
            return App.Delivery.Current.ID + "/" + App.Delivery.CurrentItem.URLName;
        case "PedidoConfirmacion":
            return App.Pedido.CurrentOrderID;
        case "UsuarioDireccion":
            return App.Usuario.CurrentDireccion.AddressDialogID;
        case "UsuarioPedido":
            return App.Usuario.CurrentPedido;
    }
    return "";
}

AnalyticsController.prototype.PageShowPostProcessing = function (id) {
    switch (id) {
        case "PedidoConfirmacion":
            if (App.Pedido.CurrentOrder && !App.Pedido.CurrentOrder.IsAnalyticsProcessed) {
                _gaq.push(['_addTrans',
                    App.Pedido.CurrentOrder.AnalyticsData.TransactionID,
                    App.Pedido.CurrentOrder.StoreName,
                    App.Pedido.CurrentOrder.FinalTotal.toString(),
                    '0.00',
                    App.Pedido.CurrentOrder.DeliveryPrice.toString(),
                    App.Pedido.CurrentOrder.AnalyticsData.CityName,
                    'Buenos Aires',
                    'Argentina'
                ]);
                $.each(App.Pedido.CurrentOrder.AnalyticsData.Items, function (i, o) {
                    _gaq.push(['_addItem',
                       o.TransactionID,
                       o.SKU,
                       o.Name,
                       o.Category,
                       o.Price.toString(),
                       o.Quantity.toString()
                    ]);
                });
                _gaq.push(['_trackTrans']);
                App.Pedido.CurrentOrder.IsAnalyticsProcessed = true;
            }
            break;
    }
}