﻿function AuthenticationController() {
    BaseController.call(this, "Authentication");
    var Current = { IsAuthenticated: false };
    var BindAddresses = null;
}

AuthenticationController.prototype = Object.create(BaseController.prototype);
AuthenticationController.prototype.constructor = AuthenticationController;
App.RegisterController(AuthenticationController);

AuthenticationController.prototype.Initialize = function (callback) {
//    openFB.init({
//        appId: App.Layout.General.FacebookAppID,
//        context: "/Content/Mobile/Ref",
//        logoutRedirectURL: (App.IsMobileApp ? "http://www.relivery.com.ar/Content/Mobile/Ref/logoutcallback.html" : null)
//    });
//    this.UpdateCurrent(function () {
//        BaseController.prototype.Initialize.call(App.Authentication, callback);
//    });
    BaseController.prototype.Initialize.call(App.Authentication, callback);
}

AuthenticationController.prototype.UpdateCurrent = function (callback) {
    Utils.GetData("Mobile/Layout/CurrentAuthentication", null, function (res, data) {
        if (res) {
            App.Authentication.Current = data;
            App.Authentication.UpdateBindAddresses();
        }
        else {
            App.Authentication.ResetCurrent();
        }
        App.Layout.UpdateNotificationFlag();
        if (callback) callback(res, data);
    });
}

AuthenticationController.prototype.UpdateBindAddresses = function () {
    this.BindAddresses = null;
    if (!this.Current || !this.Current.Addresses) return;
    this.Current.BindAddresses = this.Current.Addresses.slice();
    this.Current.BindAddresses.push({ AddressName: "Agregar nueva ubicación...", AddressID: "add" });
}

AuthenticationController.prototype.UpdateCurrentNotificationsCount = function (callback) {
    Utils.GetData("Mobile/Layout/CurrentNotificationsCount", null, function (res, data) {
        if (res) {
            App.Authentication.Current.PrevNotificationsCount = App.Authentication.Current.NotificationsCount;
            App.Authentication.Current.NotificationsCount = data;
            App.Layout.UpdateNotificationFlag();
        }
        if (callback) callback(res, data);
    });
}

AuthenticationController.prototype.LogIn = function (user, pass, remember, callback) {
    this.ResetCurrent();
    var postdata = { email: user, password: pass, remember: remember, isorder: false, url: "" };
    Utils.PostData("Mobile/Usuario/Ingresar", postdata, function (res, data) {
        if (res && data && data.Success) {
            App.Authentication.UpdateCurrent(function () { callback(res, data); });
        }
        else {
            if (callback) callback(res, data);
        }
    });
}

AuthenticationController.prototype.LogInFB = function (callback) {
    openFB.login(function (response) {
        if (response.status === 'connected') {
            Utils.PostData("Mobile/Usuario/FBLogin", { token: response.authResponse.token }, function (res, data) {
                if (res) {
                    App.Authentication.UpdateCurrent(function () {
                        callback(true, { ErrorMessage: "", Success: true });
                    });
                }
            });
        }
        else {
            callback(false, { ErrorMessage: response.status, Success: false });
        }
    }, { scope: 'email' });
}

AuthenticationController.prototype.LogOut = function (callback) {
    Utils.PostData("Mobile/Usuario/Salir", null, function (res, data) {
        if (res) {
            if (App.IsMobileApp && App.Authentication.Current && App.Authentication.Current.FacebookAuthenticationInfo && App.Authentication.Current.FacebookAuthenticationInfo.IsFacebookAuthenticated) {
                openFB.logout(function () {
                    App.Authentication.ResetCurrent();
                    if (callback) callback(res, data);
                });
                return;
            }
            App.Authentication.ResetCurrent();
        }
        if (callback) callback(res, data);
    });
}

AuthenticationController.prototype.ResetCurrent = function () {
    App.Authentication.Current = { IsAuthenticated: false };
    App.Authentication.BindAddresses = null;
    App.Layout.UpdateNotificationFlag();
}