﻿function BuscarController() {
    BaseController.call(this, "Buscar");
    this.CurrentSearch = null;
    this.IsSearching = false;
    this.CurrentSearchCall = null;
    this.BuscarIndexContent = null;
    this.BuscarIndexLoading = null;
    this.BuscarIndexResults = null;
    this.BuscarIndexLast = null;
    this.BuscarIndexEmpty = null;
}

BuscarController.prototype = Object.create(BaseController.prototype);
BuscarController.prototype.constructor = BuscarController;
App.RegisterController(BuscarController);

BuscarController.prototype.Initialize = function (callback) {
    App.RegisterPageInitializer("BuscarIndex", this.InitializeBuscarIndex);
    BaseController.prototype.Initialize.call(this, callback);
}

BuscarController.prototype.InitializeBuscarIndex = function () {
    $("#BuscarIndexPanelBtn > .off > .b0").click(function () {
        App.Home.Show();
    });
    $("#BuscarIndexPanelBtn > .off > .b1").click(function () {
        App.Buscar.ToggleFilterPanel();
    });
    $("#BuscarIndexPanelBtn > .on > .b1").click(function () {
        App.Buscar.ToggleFilterPanel();
        App.Buscar.Filter();
    });
    $("#BuscarIndexPanelBtn > .on > .b2").click(function () {
        App.Buscar.ToggleFilterPanel();
    });
    $("#BuscarIndexResults").on("click", ".item", function () {
        if (App.Buscar.BuscarIndexScroller) App.Buscar.BuscarIndexScroller.SaveContentScroll();
        var id = $(this).data("id");
        App.Buscar.LoadItem(id);
    });
    $("#BuscarIndex").on("pageshow", function () {
        if (App.Buscar.BuscarIndexScroller) App.Buscar.BuscarIndexScroller.LoadContentScroll();
    });
    $("#BuscarIndex").on("click", "a.sugerir", function () {
        App.Contacto.ShowSuggestStore();
        return false;
    });
    BaseController.prototype.InitializePageScroller.call(App.Buscar, "BuscarIndex");
    App.Buscar.BuscarIndexContent = $("#BuscarIndex .content");
    App.Buscar.BuscarIndexLoading = $("#BuscarIndexLoading");
    App.Buscar.BuscarIndexResults = $("#BuscarIndexResults");
    App.Buscar.BuscarIndexLast = $("#BuscarIndexLast");
    App.Buscar.BuscarIndexEmpty = $("#BuscarIndexEmpty");
    App.Buscar.BuscarIndexContent.scroll(function () {
        App.Buscar.NextPage();
    });
}

BuscarController.prototype.ToggleFilterPanel = function () {
    var o = $("#BuscarIndexPanel");
    var visible = o.is(':visible');
    var on = $("#BuscarIndexPanelBtn > .on");
    var off = $("#BuscarIndexPanelBtn > .off");
    if (visible) {
        o.slideUp();
        off.show();
        on.hide();
    }
    else {
        o.slideDown();
        o.scrollTop(0);
        off.hide();
        on.show();
    }
}

BuscarController.prototype.HasCurrentSearch = function () {
    return (this.CurrentSearch == null);
}

BuscarController.prototype.SetCurrentSearch = function (address, city, lat, lon, addressId, filters) {
    this.CurrentSearch = { Address: address, City: city, Latitude: lat, Longitude: lon, Page: 1, HasMorePages: false, AddressID: addressId };
    this.CurrentSearch.Filters = null;
    if (filters) this.CurrentSearch.Filters = filters;
}

BuscarController.prototype.UpdateCurrentSearchFilters = function () {
    if (!this.CurrentSearch) return;
    var cats = $("#BuscarIndexFilterCategorias input:checkbox");
    var filter_categorias = [];
    for (var i = 0; i < cats.length; i++) {
        if ($(cats[i]).is(':checked')) {
            filter_categorias.push($(cats[i]).val());
        }
    }
    this.CurrentSearch.Filters = {
        Tipo: $("#BuscarIndexFilterTipo").val().toLowerCase(),
        Tarjeta: $("#BuscarIndexFilterTarjeta").is(':checked') ? "1" : null,
        Abierto: $("#BuscarIndexFilterAbierto").is(':checked') ? "1" : null,
        Favoritos: $("#BuscarIndexFilterFavoritos").is(':checked') ? "1" : null,
        Promo: $("#BuscarIndexFilterPromo").is(':checked') ? "1" : null,
        Demora: $("#BuscarIndexFilterDemora").val(),
        Orden: $("#BuscarIndexFilterOrden").val(),
        Categorias: filter_categorias
    };
    this.CurrentSearch.Page = 1;
    this.CurrentSearch.HasMorePages = false;
}

BuscarController.prototype.GetCurrentSearchParams = function () {
    var res = {
        dirid: this.CurrentSearch.AddressID,
        dir: this.CurrentSearch.Address,
        localidad: this.CurrentSearch.City,
        lat: this.CurrentSearch.Latitude,
        lon: this.CurrentSearch.Longitude,
        p: this.CurrentSearch.Page,
        zona: "si"
    };
    if (this.CurrentSearch.Filters) {
        res.tipo = this.CurrentSearch.Filters.Tipo;
        res.tarjeta = this.CurrentSearch.Filters.Tarjeta;
        res.abierto = this.CurrentSearch.Filters.Abierto;
        res.favoritos = this.CurrentSearch.Filters.Favoritos;
        res.promo = this.CurrentSearch.Filters.Promo;
        res.demora = this.CurrentSearch.Filters.Demora;
        res.orden = this.CurrentSearch.Filters.Orden;
        res.categorias = this.CurrentSearch.Filters.Categorias;
    }
    return res;
}

BuscarController.prototype.Favorites = function () {
    App.Layout.Dialog.Loading.Open();
    this.DoSearch(null, null, null, null, null, function (res, data) {
        if (res) {
            App.Layout.Dialog.Loading.Close(function () {
                App.Buscar.ShowBuscarIndex();
            });
        }
    }, { Favoritos: "1" });
}

BuscarController.prototype.ShowBuscarIndex = function () {
    $.mobile.changePage("#BuscarIndex");
}

BuscarController.prototype.DoSearch = function (address, city, lat, lon, addressId, callback, filters) {
    if (!this.StartSearch(true)) return;
    if (this.BuscarIndexScroller) this.BuscarIndexScroller.ResetContentScroll();
    this.SetCurrentSearch(address, city, lat, lon, addressId, filters);
    this.CurrentSearchCall = Utils.PostData("Mobile/Buscar/Mas", this.GetCurrentSearchParams(), function (res, data) {
        App.Buscar.DoSearchCallback(res, data, false, false);
        App.Buscar.ResetFilters();
        App.Buscar.EndSearch();
        if (callback) callback(res, data);
    });
}

BuscarController.prototype.NextPage = function () {
    if (this.IsSearching || (this.CurrentSearch == null) || (!this.CurrentSearch.HasMorePages)) return;
    var diff = this.BuscarIndexContent.prop('scrollHeight') - (this.BuscarIndexContent.scrollTop() + this.BuscarIndexContent.height());
    if (diff > 100) return;
    if (!this.StartSearch(false)) return;
    this.CurrentSearch.Page++;
    this.CurrentSearchCall = Utils.PostData("Mobile/Buscar/Mas", this.GetCurrentSearchParams(), function (res, data) {
        App.Buscar.DoSearchCallback(res, data, true, true);
        App.Buscar.EndSearch();
    });
}

BuscarController.prototype.Filter = function () {
    if (!this.StartSearch(true)) return;
    this.SetLoading(0, true);
    this.UpdateCurrentSearchFilters();
    this.CurrentSearchCall = Utils.PostData("Mobile/Buscar/Mas", this.GetCurrentSearchParams(), function (res, data) {
        App.Buscar.DoSearchCallback(res, data, false, true);
        App.Buscar.EndSearch();
    });
}

BuscarController.prototype.StartSearch = function (canCancelCurrent) {
    if (this.IsSearching) {
        if (canCancelCurrent) {
            if (this.CurrentSearchCall && this.CurrentSearchCall.abort) this.CurrentSearchCall.abort();
            this.CurrentSearchCall = null;
        }
        else {
            return false;
        }
    }
    this.IsSearching = true;
    return true;
}

BuscarController.prototype.EndSearch = function () {
    if (!this.IsSearching) return false;
    this.CurrentSearchCall = null;
    this.IsSearching = false;
    return true;
}

BuscarController.prototype.DoSearchCallback = function (res, data, append, animate) {
    if (res) {
        for (var ii = 0; ii < data.Results.length; ii++) {
            data.Results[ii].Picture = Utils.GetPath(data.Results[ii].Picture);
            if (data.Results[ii].HasRanking) {
                for (var i = 0; i < 5; i++) {
                    data.Results[ii]["Ranking" + (i + 1)] = (data.Results[ii].Ranking >= (i * 2) + 2) ? "fa-star" : ((data.Results[ii].Ranking >= (i * 2) + 1) ? "fa-star-half-o" : "fa-star-o");
                }
            }
        }
        var o = Utils.DataBind(data, "BuscarIndexResults", false, (append ? true : false));
        if (animate) {
            o.fadeIn();
        }
        else {
            o.show();
        }
        App.Buscar.CurrentSearch.HasMorePages = data.HasMorePages ? true : false;
        App.Buscar.SetLoading(data.Results.length, false);
    }
}

BuscarController.prototype.SetLoading = function (count, filtering) {
    loading = this.BuscarIndexLoading;
    last = this.BuscarIndexLast;
    empty = this.BuscarIndexEmpty;
    if (!loading) loading = $("#BuscarIndexLoading");
    if (!last) last = $("#BuscarIndexLast");
    if (!empty) empty = $("#BuscarIndexEmpty");
    if (filtering) {
        last.hide();
        empty.hide();
        loading.show();
        if (this.BuscarIndexScroller) this.BuscarIndexScroller.ResetContentScroll();
        if (this.BuscarIndexResults) this.BuscarIndexResults.empty();
        return;
    }
    if (this.CurrentSearch.HasMorePages) {
        loading.show();
        last.hide();
        empty.hide();
    }
    else {
        loading.hide();
        if ((this.CurrentSearch.Page == 1) && (count == 0)) {
            empty.show();
            last.hide();
        }
        else {
            empty.hide();
            last.show();
        }
    }
}

BuscarController.prototype.ResetFilters = function () {
    Utils.DataBind(App.Layout.General.BuscarOrder, "BuscarIndexFilterOrden", true);
    Utils.DataBind(App.Layout.General.OrderType, "BuscarIndexFilterTipo", true);
    Utils.DataBind(App.Layout.General.BuscarDeliveryTime, "BuscarIndexFilterDemora", true);
    Utils.DataBind(App.Layout.General.Category, "BuscarIndexFilterCategorias");
    Utils.DataBind(App.Authentication.Current, "BuscarIndexFiltersGroup");
}

BuscarController.prototype.LoadItem = function (id) {
    App.Layout.Dialog.Loading.Open();
    App.Delivery.SetCurrent(id, App.Buscar.LoadItemCallback);
}

BuscarController.prototype.LoadItemCallback = function (res, data) {
    if (res) {
        App.Layout.Dialog.Loading.Close(function () {
            $.mobile.changePage("#DeliveryIndex");
        });
    }
}