﻿function DeliveryController() {
    BaseController.call(this, "Delivery");
    this.DeliveryIndexContent = null;
    this.Current = null;
    this.CurrentItem = null;
}

DeliveryController.prototype = Object.create(BaseController.prototype);
DeliveryController.prototype.constructor = DeliveryController;
App.RegisterController(DeliveryController);

DeliveryController.prototype.Initialize = function (callback) {
    App.RegisterPageInitializer("DeliveryIndex", this.InitializeDeliveryIndex);
    App.RegisterPageInitializer("DeliveryAgregar", this.InitializeDeliveryAgregar);
    BaseController.prototype.Initialize.call(this, callback);
}

DeliveryController.prototype.InitializeDeliveryIndex = function () {
    $("#DeliveryIndexPanelBtn > .b1").click(function () {
        App.Delivery.ToggleFilterPanel();
    });
    $("#DeliveryIndexPanelBtn > .b2").click(function () {
        App.Pedido.ShowIndex();
    });
    $("#DeliveryIndexPanelCategories").on("click", "a", function () {
        var id = $(this).data("id");
        App.Delivery.ToggleFilterPanel();
        App.Delivery.GoToCategory(id);
    });
    $("#DeliveryIndexMenu").on("click", ".items .item", function () {
        var id = $(this).data("id");
        App.Delivery.ShowCurrentItem(id);
    });
    $("#DeliveryIndexDetails").on("click", "#DeliveryIndexFavAdd", function () {
        App.Delivery.FavoriteCurrent(true);
    });
    $("#DeliveryIndexDetails").on("click", "#DeliveryIndexFavRem", function () {
        App.Delivery.FavoriteCurrent(false);
    });
    $("#DeliveryIndexBack").on("click", function () {
        App.Buscar.ShowBuscarIndex();
    });
    $("#DeliveryIndex").on("pageshow", function () {
        if (App.Delivery.DeliveryIndexScroller) App.Delivery.DeliveryIndexScroller.LoadContentScroll();
    });
    App.Delivery.DeliveryIndexContent = $("#DeliveryIndex .content");
    BaseController.prototype.InitializePageScroller.call(App.Delivery, "DeliveryIndex");
}

DeliveryController.prototype.ToggleFilterPanel = function () {
    var o = $("#DeliveryIndexPanel");
    var visible = o.is(':visible');
    if (visible) {
        o.slideUp();
    }
    else {
        o.slideDown();
        o.scrollTop(0);
    }
}

DeliveryController.prototype.GoToCategory = function (id) {
    var o = $("#DeliveryIndexMenu-" + id);
    if (o.length > 0 && this.DeliveryIndexContent) {
        this.DeliveryIndexContent.animate({
            scrollTop: this.DeliveryIndexContent.scrollTop() + o.offset().top - 65
        }, 700);
    }
}

DeliveryController.prototype.FavoriteCurrent = function (isAdd) {
    App.Layout.Dialog.Loading.Open();
    if (!App.Authentication.Current.IsAuthenticated) return;
    Utils.PostData("Mobile/Usuario/Favorito", { id: this.Current.Nick }, function (res, data) {
        if (res) {
            if (data.Success) {
                if (data.Added) {
                    $("#DeliveryIndexFavAdd").hide();
                    $("#DeliveryIndexFavRem").show();
                }
                else {
                    $("#DeliveryIndexFavRem").hide();
                    $("#DeliveryIndexFavAdd").show();
                }
            }
            App.Layout.Dialog.Loading.Close();
        }
    });

}

DeliveryController.prototype.SetCurrent = function (name, callback) {
    if (App.Delivery.DeliveryIndexScroller) App.Delivery.DeliveryIndexScroller.ResetContentScroll();
    Utils.PostData("Mobile/Delivery/Index", { ID: name }, function (res, data) {
        App.Delivery.DoSetCurrentCallback(res, data, callback);
    });
}

DeliveryController.prototype.DoSetCurrentCallback = function (result, data, callback) {
    if (result) {
        if (data.HasRanking) {
            for (var i = 0; i < 5; i++) {
                data["Ranking" + (i + 1)] = (data.Ranking >= (i * 2) + 2) ? "fa-star" : ((data.Ranking >= (i * 2) + 1) ? "fa-star-half-o" : "fa-star-o");
            }
        }
        if (data.IsFavorite || !App.Authentication.Current.IsAuthenticated) {
            data.FavoriteAddStyle = "display: none;";
        }
        if (!data.IsFavorite || !App.Authentication.Current.IsAuthenticated) {
            data.FavoriteRemoveStyle = "display: none;";
        }
        App.Delivery.Current = data;
        data.Picture = Utils.GetPath(data.Picture);
        Utils.DataBind(data, "DeliveryIndexDetails", false, false);
        Utils.DataBind(data, "DeliveryIndexPromotions", false, false);
        Utils.DataBind(data, "DeliveryIndexMenu", false, false);
        Utils.DataBind(data, "DeliveryIndexPanelCategories", false, false);
        if (data.HasOutdatedPrices) {
            App.Layout.Dialog.Loading.Close(function () {
                App.Layout.Dialog.Alert.Open(
                    "Menú en actualización",
                    "Este comercio está actualizando sus precios. Podés realizar el pedido igual y si hubiese alguna diferencia en los productos que elegiste, el total exacto será confirmado al procesarse el pedido.",
                    function () {
                        App.Layout.Dialog.Loading.Open();
                        if (callback) window.setTimeout(function () { callback(result, data) }, 500);
                    }
                )
            });
        }
        else {
            if (callback) callback(result, data);
        }
    }
}

DeliveryController.prototype.InitializeDeliveryAgregar = function () {
    $("#DeliveryAgregarPanel .off .b1").click(function () {
        App.Delivery.AddCurrentItem(function (res, data) {
            if (res && data && data.Success) {
                App.Layout.ShowToast("Se agregó el producto a tu pedido.");
                $.mobile.changePage("#DeliveryIndex");
            }
        });
    });
    $("#DeliveryAgregarPanel .off .b2").click(function () {
        $.mobile.changePage("#DeliveryIndex");
    });
    $("#DeliveryAgregarAttributes").on("keyup", ".addnums .addnum input", App.Delivery.InitializeDeliveryAgregarOptionHandler);
    $("#DeliveryAgregarAttributes").on("click", ".addnums .addnum .plus", App.Delivery.InitializeDeliveryAgregarOptionHandler);
    $("#DeliveryAgregarAttributes").on("click", ".addnums .addnum .minus", App.Delivery.InitializeDeliveryAgregarOptionHandler);
    $("#DeliveryAgregarAttributes").on("change", ".addcheck input:checkbox", App.Delivery.InitializeDeliveryAgregarOptionHandler);
    $("#DeliveryAgregarAttributes").on("change", ".addselect select", App.Delivery.InitializeDeliveryAgregarOptionHandler);
    $("#DeliveryAgregarBasic").on("keyup", ".addnum input", App.Delivery.InitializeDeliveryAgregarQuantityHandler);
    $("#DeliveryAgregarBasic").on("click", ".addnum .plus", App.Delivery.InitializeDeliveryAgregarQuantityHandler);
    $("#DeliveryAgregarBasic").on("click", ".addnum .minus", App.Delivery.InitializeDeliveryAgregarQuantityHandler);
    $("#DeliveryAgregarInputNotes").on("focus", function () {
        $("#DeliveryAgregarPanel").hide();
        $("#DeliveryAgregar .content").removeClass("hasfooter");
    });
    $("#DeliveryAgregarInputNotes").on("blur", function () {
        $("#DeliveryAgregar .content").addClass("hasfooter");
        $("#DeliveryAgregarPanel").show();
    });
    $("#DeliveryAgregarInputNotes").data("placeholder", App.Layout.General.ItemCommentWatermark);
    Utils.UI.InitWatermark("DeliveryAgregarInputNotes");
    BaseController.prototype.InitializeForm.call(App.Delivery, "DeliveryAgregar", function () {
        var e = $("#DeliveryAgregarInputQuantity");
        BaseController.prototype.ScrollPageToInput.call(this, "DeliveryAgregar", e, true);
        window.setTimeout(function() { $("#DeliveryAgregarInputNotes").blur(); }, 100);
    });
}

DeliveryController.prototype.ShowCurrentItem = function (id) {
    if (App.Delivery.Current && App.Delivery.Current.IsUnavailable) {
        App.Layout.Dialog.Alert.Open(App.Delivery.Current.UnavailableTitle, App.Delivery.Current.UnavailableMessage);
        return false;
    }
    if (App.Delivery.Current && App.Delivery.Current.ShowItemDialogConfirm) {
        var items = [{ Text: "Continuar", Value: true }, { Text: "Cancelar", Value: false}];
        App.Layout.Dialog.Select.Open(
            "Pedido pendiente",
            "Si agregás productos de otro comercio se eliminará el pedido pendiente ¿Estás seguro?",
            items, "Text",
            function (eo) {
                if (eo.data.Value == true) {
                    App.Delivery.Current.ShowItemDialogConfirm = false;
                    setTimeout(function () { App.Delivery.ShowCurrentItem(id); }, 1);
                }
            });
        return false;
    }
    if (App.Delivery.DeliveryIndexScroller) App.Delivery.DeliveryIndexScroller.SaveContentScroll();
    App.Layout.Dialog.Loading.Open();
    App.Delivery.SetCurrentItem(id, function (res, data) {
        if (res) {
            App.Layout.Dialog.Loading.Close(function () {
                $.mobile.changePage("#DeliveryAgregar");
            });
        }
    });
}

DeliveryController.prototype.SetCurrentItem = function (id, callback) {
    Utils.GetData("Mobile/Delivery/Agregar", { ID: id }, function (res, data) {
        App.Delivery.DoSetCurrentItemCallback(res, data);
        if (callback) callback(res, data);
    });
}

DeliveryController.prototype.DoSetCurrentItemCallback = function (result, data) {
    if (result) {
        this.CurrentItem = data;
        $("#DeliveryAgregarTitle").text(data.Name);
        $("#DeliveryAgregarDesc").text(data.Description);
        $("#DeliveryAgregarInputNotes").val(data.Notes);
        $("#DeliveryAgregarInputNotes").focusout();
        $("#DeliveryAgregarInputQuantity").val(data.Quantity);
        $("#DeliveryAgregarAttributes").empty();
        var template = "";
        for (var i = 0; i < data.Attributes.length; i++) {
            template = "DeliveryAgregarAttributesSelect-Template";
            if (data.Attributes[i].IsMultiSelect) template = "DeliveryAgregarAttributesMulti-Template";
            if (data.Attributes[i].IsQuantitySelect) template = "DeliveryAgregarAttributesQuantity-Template";
            Utils.DataBind(data.Attributes[i], "DeliveryAgregarAttributes", false, true, false, template);
            if (data.Attributes[i].IsSize) {
                var oa = $("#DeliveryAgregarAttributeSelect-" + data.Attributes[i].ID);
                oa.children().last().attr('selected', 'selected');
                oa.trigger("change");
            }
            this.UpdateItemAttribute(data.Attributes[i]);
        }
        this.UpdateItemAttribute();
    }
}

DeliveryController.prototype.InitializeDeliveryAgregarOptionHandler = function () {
    var o = $(this);
    var attribute = o.closest(".attr");
    var attributeId = attribute.data("id");
    var attributeData = Utils.Array.FindFirst(App.Delivery.CurrentItem.Attributes, "ID", attributeId);
    if (!attributeId || !attributeData) return;
    var optionId = null;
    var option = null;
    var action = null;
    if (attributeData.IsQuantitySelect) {
        option = o.closest(".addnum");
        if (o.hasClass("plus")) action = "plus";
        if (o.hasClass("minus")) action = "minus";
        if (o.is('input:text')) action = o.val();
        optionId = option.data("id");
    }
    if (attributeData.IsMultiSelect) {
        option = o;
        action = "minus";
        if (o.is(':checked')) action = "plus";
        optionId = option.data("id");
    }
    if (attributeData.IsSingleSelect) {
        option = o;
        action = "plus";
        optionId = option.val();
    }
    App.Delivery.UpdateItemAttribute(attributeData, optionId, action);
}

DeliveryController.prototype.InitializeDeliveryAgregarQuantityHandler = function () {
    var o = $(this);
    var value = 1;
    var updateVal = false;
    if (o.is('input:text')) {
        value = parseInt(o.val(), 10);
    } else {
        if (o.hasClass("plus")) value = App.Delivery.CurrentItem.Quantity + 1;
        if (o.hasClass("minus")) value = App.Delivery.CurrentItem.Quantity - 1;
        updateVal = true;
    }
    if (isNaN(value) || (value < 1) || (value > 99)) value = 1;
    if (updateVal) $("#DeliveryAgregarInputQuantity").val(value);
    App.Delivery.CurrentItem.Quantity = value;
    App.Delivery.UpdateItemAttribute();
}

DeliveryController.prototype.UpdateItemAttribute = function (attributeData, optionId, action) {
    var value = 0;
    var optionData = null;
    if (attributeData) {
        if (!optionId && !action) {
            if (attributeData.IsSingleSelect) {
                action = "plus";
                optionId = $("#DeliveryAgregarAttributeSelect-" + attributeData.ID).val();
            }
        }
        if (optionId) optionData = Utils.Array.FindFirst(attributeData.Options, "ID", optionId);
        if (optionData && action) {
            if (!optionData.Quantity) optionData.Quantity = 0;
            if (!attributeData.IsQuantitySelect) {
                if (action == "plus") value = 1;
                if (attributeData.IsSingleSelect) {
                    $.each(attributeData.Options, function (i, v) { v.Quantity = 0; });
                }
            }
            else {
                switch (action) {
                    case "plus":
                        value = optionData.Quantity + 1;
                        if (value > 99) value = 99;
                        $("#DeliveryAgregarOption-" + optionId).val(value);
                        break;
                    case "minus":
                        value = optionData.Quantity - 1;
                        if (value < 0) value = 0;
                        $("#DeliveryAgregarOption-" + optionId).val(value);
                        break;
                    default:
                        value = parseInt($("#DeliveryAgregarOption-" + optionId).val(), 10);
                        if (isNaN(value)) value = 0;
                        break;
                }
            }
            optionData.Quantity = value;
        }
    }
    var price = this.CurrentItem.Price;
    $.each(this.CurrentItem.Attributes, function (i, a) {
        $.each(a.Options, function (ii, o) {
            price += (o.Quantity * o.PriceVariation);
        });
    });
    price = price * this.CurrentItem.Quantity;
    $("#DeliveryAgregarPanel .price strong").text("$ " + price.toFixed(2));
    if (attributeData) {
        this.ValidateItemAttribute(attributeData);
    }
}

DeliveryController.prototype.ValidateItemAttribute = function (attributeData) {
    var value = 0;
    var valItemQuantity = true;
    $.each(attributeData.Options, function (i, v) {
        value += v.Quantity;
        if (attributeData.IsSingleSelect) return;
        if (v.Quantity < attributeData.MinItemQuantity || (v.Quantity > attributeData.MaxItemQuantity && attributeData.MaxItemQuantity > 0)) {
            valItemQuantity = false;
        }
    });
    var errormsg = "";
    if (!valItemQuantity) {
        errormsg = this.ValidateItemAttributeMessages(attributeData.MinItemQuantity, attributeData.MaxItemQuantity, true);
    }
    if (value < attributeData.MinTotalQuantity || (value > attributeData.MaxTotalQuantity && attributeData.MaxTotalQuantity > 0)) {
        errormsg = this.ValidateItemAttributeMessages(attributeData.MinTotalQuantity, attributeData.MaxTotalQuantity, false);
    }
    if (!attributeData.IsSingleSelect) {
        var quantityLabel = $('#DeliveryAgregarQuantity-' + attributeData.ID + ' strong');
        quantityLabel.text(value + ((attributeData.MaxTotalQuantity > 0) ? " de " + attributeData.MaxTotalQuantity : ""));
    }
    $('#DeliveryAgregarQuantity-' + attributeData.ID + ' .val').html(errormsg);
    if (!errormsg || errormsg == "") return true;
    return false;
}

DeliveryController.prototype.ValidateItemAttributeMessages = function (min, max, item) {
    var res = "<i class='fa fa-warning'></i> Seleccioná entre " + min + " y " + max;
    if (min == 0) res = "<i class='fa fa-warning'></i> Seleccioná no más de " + max;
    if (max == 0) res = "<i class='fa fa-warning'></i> Seleccioná al menos " + min;
    if (max == min) res = "<i class='fa fa-warning'></i> Seleccioná " + max;
    if (item) res = res + " por opción";
    return res;
}

DeliveryController.prototype.ValidateCurrentItem = function () {
    if (!this.CurrentItem) return;
    var res = true;
    $.each(this.CurrentItem.Attributes, function (i, v) {
        res = res && App.Delivery.ValidateItemAttribute(v);
    });
    if (!res) {
        App.Layout.Dialog.Alert.Open("Error", "Corregí los errores antes de continuar");
    }
    return res;
}

DeliveryController.prototype.AddCurrentItem = function (callback) {
    var val = this.ValidateCurrentItem();
    if (!val || !this.CurrentItem) return;
    App.Layout.Dialog.Loading.Open();
    var notes = $("#DeliveryAgregarInputNotes");
    this.CurrentItem.Notes = notes.val();
    if (!this.CurrentItem.Notes || notes.hasClass("watermark")) this.CurrentItem.Notes = "";
    var data = {
        SRI_menu_item_id: this.CurrentItem.ID,
        SRI_order_item_id: this.CurrentItem.OrderItemID,
        SRI_quantity: this.CurrentItem.Quantity,
        SRI_comment: this.CurrentItem.Notes
    };
    $.each(this.CurrentItem.Attributes, function (i, a) {
        $.each(a.Options, function (ii, o) {
            if (a.IsMultiSelect || a.IsQuantitySelect) {
                data["SRI_opt_" + o.ID] = o.Quantity;
            }
            else {
                if (o.Quantity > 0) {
                    data["SRI_attr_" + a.ID] = o.ID;
                }
            }
        });
    });
    Utils.PostData("Mobile/Delivery/Agregar", data, function (res, data) {
        if (res) {
            App.Layout.Dialog.Loading.Close(function () {
                if (res && !data.Success) {
                    App.Layout.Dialog.Alert.Open("Error", data.Error);
                }
                if (callback) callback(res, data);
            });
        }
        else { if (callback) callback(res, data); }
    });
}