﻿function Relivery() {
    this.IsMobileApp = true;
    this.BaseRequestPath = "http://www.relivery.com.ar/";
    this.BaseFilePath = "http://www.relivery.com.ar/";
    this.Initialized = false;
    this.Controllers = new Array();
    this.CreatedPages = new Array();
    $(document).bind("mobileinit", function () { App.InitializeMobile(); });
    $(document).bind("pagecreate", function (e) { App.PageCreateHandler(e); });
    $(document).ready(function () { App.Initialize(); });
    if (this.IsMobileApp) {
        document.addEventListener("deviceready", function () { App.InitializeMobileApp(); }, false);
    }
}

var App = new Relivery();

Relivery.prototype.RegisterController = function (type) {
    var c = new type();
    this.Controllers.push(c);
    this[c.Name] = c;
}

Relivery.prototype.RegisterPageInitializer = function (pageId, handler) {
    if ($.inArray(pageId, this.CreatedPages) > -1) {
        handler();
    }
    else {
        $(document).on("pagecreate", "#" + pageId, function () { handler(); });
    }
}

Relivery.prototype.InitializeMobileApp = function () {
    if (device && StatusBar) {
        if (device.platform == "iOS") {
            StatusBar.overlaysWebView(false);
            StatusBar.styleDefault();
            StatusBar.backgroundColorByHexString("#EEEEEE");
        }
        if (device.platform == "WinCE" || device.platform == "Windows" || (this.Device && this.Device.IsWindows)) {
            StatusBar.hide();
        }
    }
}

Relivery.prototype.InitializeMobile = function () {
    if (this.IsMobileApp) {
        $.support.cors = true;
        $.mobile.allowCrossDomainPages = true;
    }
    $.mobile.pageContainer = $('#container');
    $.mobile.defaultPageTransition = 'fade';
    $.mobile.defaultDialogTransition = 'fade';
    $.mobile.phonegapNavigationEnabled = this.IsMobileApp;
    $.mobile.pushStateEnabled = true;
    $.mobile.hashListeningEnabled = true;
    $.support.touchOverflow = true;
    $.mobile.touchOverflowEnabled = true;
    window.onresize = function () { $(document.body).width(window.innerWidth).height(window.innerHeight); };
    window.onresize();
    $(document).on('touchmove', function (e) {
        var searchTerms = '.scrollable, div[data-role="content"], div[data-role="panel"], .panelup';
        var $target = $(e.target);
        var parents = $target.parents(searchTerms);
        var isTarget = ($target.filter(searchTerms).length > 0);
        var o = $target;
        if (parents.length || isTarget) {
            o = isTarget ? $target : parents;
        } else {
            e.preventDefault();
            e.stopPropagation();
        }
    });
    this.RegisterPageInitializer('AppLoading', function () {
        $('#AppLoading').on("pageshow", function () {
            if (App.Initialized) {
                App.InitializeCompleteRedirect();
            }
        });
    });
}

Relivery.prototype.Initialize = function () {
    this.Device = {
        IsAndroid: /(android)/g.test(navigator.userAgent.toLowerCase()),
        IsIOS: /(ipad|iphone|ipod)/g.test(navigator.userAgent.toLowerCase()),
        IsWindows: /(windows)/g.test(navigator.userAgent.toLowerCase())
    };
    if (this.Device.IsAndroid) $("body").addClass("device-android");
    if (this.Device.IsIOS) $("body").addClass("device-ios");
    if (this.Device.IsWindows) $("body").addClass("device-windows");
    this.Controllers[0].Initialize(this.InitializeControllersCallback);
}

Relivery.prototype.InitializeComplete = function () {
    this.Initialized = true;
    this.InitializeCompleteRedirect();
}

Relivery.prototype.InitializeCompleteRedirect = function () {
    App.Home.ShowIntro();
}

Relivery.prototype.InitializeControllersCallback = function (controller) {
    var i = $.inArray(controller, App.Controllers);
    if (i < 0) return;
    i++;
    if (i < App.Controllers.length) {
        App.Controllers[i].Initialize(App.InitializeControllersCallback);
    }
    else {
        App.InitializeComplete();
    }
}

Relivery.prototype.PageCreateHandler = function (event) {
    this.CreatedPages.push(event.target.id);
    if (this.Layout) this.Layout.InitializePageLayout(event.target.id);
}

Relivery.prototype.RequestErrorHandler = function () {
    if (App && App.Layout && App.Layout.Dialog) {
        App.Layout.Dialog.Loading.Close();
        App.Layout.Dialog.Searching.Close();
        window.setTimeout(function () {
            App.Layout.Dialog.Alert.Open("Error", "No se pudo obtener la información, chequea tu conexión a internet y volvé a intentar");
        }, 600);
        return;
    }
    Utils.Alert("ERROR: No se pudo obtener la información, chequea tu conexión a internet y volvé a intentar");
}