﻿function PedidoController() {
    BaseController.call(this, "Pedido");
    this.PedidoIndexForm = null;
    this.CurrentStoreID = null;
    this.CurrentOrderID = null;
    this.CurrentOrder = null;
    this.AddressChangeIgnore = false;
}

PedidoController.prototype = Object.create(BaseController.prototype);
PedidoController.prototype.constructor = PedidoController;
App.RegisterController(PedidoController);

PedidoController.prototype.Initialize = function (callback) {
    App.RegisterPageInitializer("PedidoIndex", this.InitializePedidoIndex);
    App.RegisterPageInitializer("PedidoConfirmacion", this.InitializePedidoConfirmacion);
    BaseController.prototype.Initialize.call(this, callback);
}

PedidoController.prototype.InitializePedidoIndex = function () {
    this.PedidoIndexForm = $("#PedidoIndexForm");
    $("#PedidoIndexForm").on("change", "#PedidoIndexOrderType", function () {
        App.Pedido.OrderTypeRefresh();
    });
    $("#PedidoIndex").on("pageshow", function () {
        if (App.Pedido.PedidoIndexScroller) App.Pedido.PedidoIndexScroller.LoadContentScroll();
        BaseController.prototype.RefreshFormData.call(App.Pedido, "PedidoIndex", App.Pedido.DoOrder, true);
    });
    $("#PedidoIndexForm").on("change", "#PedidoIndexAddress", function () {
        if (App.Pedido.AddressChangeIgnore == true) return;
        if ($("#PedidoIndexAddress").val() == "add") {
            App.Pedido.AddressChangeIgnore = true;
            if (App.Pedido.PedidoIndexScroller) App.Pedido.PedidoIndexScroller.SaveContentScroll();
            App.Usuario.ShowDireccion(null, function (res, data) {
                if (res) {
                    App.Pedido.UpdateAddress(null, data.ID);
                    App.Pedido.AddressRefresh(function () { $.mobile.changePage("#PedidoIndex"); });
                } else {
                    $.mobile.changePage("#PedidoIndex");
                }
                App.Pedido.AddressChangeIgnore = false;
            });
        }
        else {
            App.Pedido.AddressRefresh();
        }
    });
    $("#PedidoIndexForm").on("change", "#PedidoIndexDeliveryPaymentTypeCont input:radio", function () {
        App.Pedido.PaymentTypeRefresh("Delivery");
    });
    $("#PedidoIndexForm").on("change", "#PedidoIndexPickUpPaymentTypeCont input:radio", function () {
        App.Pedido.PaymentTypeRefresh("PickUp");
    });
    $("#PedidoIndexForm").on("change", "#PedidoIndexDeliveryPaysExact", function () {
        App.Pedido.PaysWithRefresh("Delivery");
    });
    $("#PedidoIndexForm").on("change", "#PedidoIndexPickUpPaysExact", function () {
        App.Pedido.PaysWithRefresh("PickUp");
    });
    $("#PedidoIndexForm").on("click", "#PedidoIndexBtnOK", function () {
        App.Pedido.DoOrder(false, false);
        return false;
    });
    $("#PedidoIndexForm").on("click", "#PedidoIndexBtnCancel", function () {
        App.Pedido.CancelRedirect();
        return false;
    });
    $("#PedidoIndexOrder").on("click", "#PedidoIndexStoreName", function () {
        App.Pedido.CancelRedirect();
        return false;
    });
    BaseController.prototype.InitializePageScroller.call(App.Pedido, "PedidoIndex");
    BaseController.prototype.InitializeForm.call(App.Pedido, "PedidoIndex", App.Pedido.DoOrder);
}

PedidoController.prototype.ShowIndex = function () {
    App.Layout.Dialog.Loading.Open();
    if (App.Pedido.PedidoIndexScroller) App.Pedido.PedidoIndexScroller.ResetContentScroll();
    App.Pedido.UpdateIndex(App.Pedido.ShowIndexCallback);
}

PedidoController.prototype.ShowIndexCallback = function (res, data) {
    if (res && data && !data.Error && data.IsAuthenticatedUser) {
        App.Layout.Dialog.Loading.Close(function () {
            $.mobile.changePage("#PedidoIndex");
        });
    }
    if (res && data && data.Error && data.NoItems) {
        App.Layout.Dialog.Loading.Close(function () {
            App.Layout.Dialog.Alert.Open("Realizar Pedido", "Todavía no hay productos en tu pedido");
        });
    }
}

PedidoController.prototype.UpdateIndex = function (callback) {
    Utils.GetData("Mobile/Pedido/Index", null, function (res, data) {
        if (res) {
            App.Pedido.AddressChangeIgnore == false;
            Utils.DataBind(data, "PedidoIndexOrder", false, false);
            if (!data.IsAuthenticatedUser) {
                App.Pedido.HideForm();
                App.Layout.Dialog.Loading.Close(function () {
                    App.Pedido.RequestLogin();
                });
            }
            else {
                if (App.IsMobileApp) {
                    data.UserHasCellPhone = false;
                }
                Utils.DataBind(data, "PedidoIndexForm", false, false);
                App.Pedido.UpdateAddress(data);
                App.Pedido.CurrentStoreID = data.StoreLink;
                App.Pedido.ShowForm();
            }
        }
        if (callback) callback(res, data);
    });
}

PedidoController.prototype.UpdateAddress = function (modelData, selectedId) {
    var data = null;
    if (modelData) {
        data = modelData.Addresses;
    }
    else {
        data = [{ Value: "", Text: "", Selected: false}];
        $.each(App.Authentication.Current.BindAddresses, function (i, o) {
            var name = o.AddressName;
            if (o.AddressID != "add") {
                name = o.AddressName + " - " + o.AddressStreet + (Utils.String.IsNullOrEmpty(o.AddressFloor) ? "" : (", Piso " + o.AddressFloor)) + (Utils.String.IsNullOrEmpty(o.AddressAppartment) ? "" : (", Depto. " + o.AddressAppartment.toUpperCase()));
            }
            data.push({ Value: o.AddressID, Text: name, Selected: (o.AddressID == selectedId) });
        });
    }
    Utils.DataBind(data, "PedidoIndexAddress", true, false);
}

PedidoController.prototype.UpdateOrder = function (zoneWarning, callback) {
    App.Layout.Dialog.Loading.Open();
    var data = {
        OrderTypeValue: $('#PedidoIndexOrderType').val(),
        AddressID: $('#PedidoIndexAddress').val()
    };
    Utils.GetData("Mobile/Pedido/Order", data, function (res, data) {
        if (res) {
            Utils.DataBind(data, "PedidoIndexOrder", false, false);
            App.Layout.Dialog.Loading.Close(function () {
                if (data.ShowZoneWarning) {
                    App.Layout.Dialog.Alert.Open("Realizar Pedido", "La ubicación seleccionada esta fuera del área de entrega del comercio", callback);
                }
                else {
                    if (callback) callback();
                }
            });
        }
    });
}

PedidoController.prototype.RequestLogin = function () {
    App.Layout.Dialog.Alert.Open("Realizar Pedido", "Ingresá para confirmar tu pedido", function () {
        App.Usuario.ShowIngresar(true);
    });
}

PedidoController.prototype.OrderTypeRefresh = function () {
    var val = $("#PedidoIndexOrderType").val()
    if (val && val == "1") {
        $("#PedidoIndexPickUp").hide();
        $("#PedidoIndexDelivery").show();
    }
    else {
        $("#PedidoIndexDelivery").hide();
        $("#PedidoIndexPickUp").show();
    }
    BaseController.prototype.RefreshFormData.call(App.Pedido, "PedidoIndex", App.Pedido.DoOrder, true);
    this.UpdateOrder(false);
}

PedidoController.prototype.AddressRefresh = function (callback) {
    this.UpdateOrder(true, callback);
}

PedidoController.prototype.DoOrder = function (alcoholClaimsAge, addressValidated) {
    App.Layout.Dialog.Loading.Open();
    var otv = $("#PedidoIndexOrderType").val();
    var isDelivery = (otv == "1");
    var data = {
        OrderTypeValue: otv,
        ExecutionDateValue: $("#PedidoIndexExecutionDate").val(),
        PaymentTypeValue: $("input:radio[name='PedidoIndexDeliveryPaymentType']:checked").val(),
        PickUpPaymentTypeValue: $("input:radio[name='PedidoIndexPickUpPaymentType']:checked").val(),
        AddressID: $("#PedidoIndexAddress").val(),
        PaysWith: isDelivery ? $("#PedidoIndexDeliveryPaysWith").val() : $("#PedidoIndexPickUpPaysWith").val(),
        PaysExact: isDelivery ? $("#PedidoIndexDeliveryPaysExact").is(':checked') : $("#PedidoIndexPickUpPaysExact").is(':checked'),
        SendSMS: $("#PedidoIndexSMS").is(':checked'),
        AddressValidated: addressValidated ? true : false,
        Notes: $("#PedidoIndexNotes").val(),
        Phone: $("#PedidoIndexPhone").val(),
        AlcoholClaimsAge: alcoholClaimsAge ? true : false
    };
    Utils.PostData("Mobile/Pedido/Index", data, function (res, data) {
        if (res) {
            App.Layout.Dialog.Loading.Close(function () {
                switch (data.Result) {
                    case "Unauthorized":
                        App.Pedido.RequestLogin();
                        break;
                    case "Failure":
                        App.Pedido.CancelRedirect();
                        break;
                    case "Completed":
                        App.Pedido.ShowConfirmacion(data.OrderID);
                        break;
                    default: //Pending
                        if (data.Errors.length > 0) {
                            App.Layout.Dialog.Alert.Open("Realizar Pedido", data.Errors);
                            return;
                        }
                        if (!App.Pedido.RequestAlcoholValidation(data.Model)) return;
                        App.Pedido.AddressValidation(data.Model);
                        break;
                }
            });
        }
    });
}

PedidoController.prototype.CancelRedirect = function () {
    if (App.Pedido.CurrentStoreID) {
        App.Buscar.LoadItem(App.Pedido.CurrentStoreID);
    }
    else {
        App.Home.Show();
    }
}

PedidoController.prototype.RequestAlcoholValidation = function (model) {
    if (!model.AlcoholValidated) {
        if (!model.AlcoholIsAllowed) {
            App.Layout.Dialog.Alert.Open("Control de bebidas alcohólicas", "La ley solo permite la venta de bebidas alcohólicas de 8 a 24 horas, no podés realizar el pedido incluyendo ese tipo de productos.");
        }
        else {
            if (!model.AlcoholIsValidAge) {
                if (!model.UserHasAge) {
                    var items = [{ Text: "Sí, soy mayor de 18 años", Value: true }, { Text: "No soy mayor de 18 años", Value: false}];
                    App.Layout.Dialog.Select.Open(
                        "Control de bebidas alcohólicas",
                        "La ley exige que confirmes tu mayoría de edad para el pedido de bebidas alcohólicas, por favor seleccioná la opción que corresponda a continuación. También podés indicar tu fecha de nacimiento en tu perfil de usuario y volver a intentar.",
                        items, "Text",
                        function (eo) {
                            if (eo.data.Value == true) {
                                setTimeout(function () { App.Pedido.DoOrder(true, false); }, 1);
                            }
                        });
                }
                else {
                    App.Layout.Dialog.Alert.Open("Control de bebidas alcohólicas", "Tu perfil de usuario indica que tenes una edad menor a 18 años. La ley no permite la venta de bebidas alcohólicas a menores, no podés realizar el pedido incluyendo ese tipo de productos.");
                }
            }
        }
    }
    else {
        return true;
    }
    return false;
}

PedidoController.prototype.AddressValidation = function (model) {
    var items = [{ Text: "Sí, enviar", Value: true }, { Text: "No, corregir", Value: false}];
    App.Layout.Dialog.Select.Open(
        "Confirmación de dirección",
        ["El pedido será enviado a:", model.DisplayFullAddress, "¿Es Correcto?"],
        items, "Text",
        function (eo) {
            if (eo.data.Value == true) {
                setTimeout(function () { App.Pedido.DoOrder(model.AlcoholValidated, true); }, 1);
            }
        });
}

PedidoController.prototype.PaymentTypeRefresh = function (type) {
    var cash = "1";
    cash = $("input:radio[name='PedidoIndex" + type + "PaymentType']:checked").val();
    var isCash = (cash && cash == "1");
    if (isCash) {
        $("#PedidoIndex" + type + "Pays").show();
    }
    else {
        $("#PedidoIndex" + type + "Pays").hide();
    }
    Utils.UI.Checkbox.Update($("#PedidoIndex" + type + "PaysExact"), !isCash);
}

PedidoController.prototype.PaysWithRefresh = function (type) {
    var exact = false;
    exact = $("#PedidoIndex" + type + "PaysExact").is(':checked');
    if (exact) {
        $("#PedidoIndex" + type + "Pays .label").hide();
        $("#PedidoIndex" + type + "Pays .input").hide();
    }
    else {
        $("#PedidoIndex" + type + "Pays .label").show();
        $("#PedidoIndex" + type + "Pays .input").show();
    }
}

PedidoController.prototype.HideForm = function () {
    if (this.PedidoIndexForm) this.PedidoIndexForm.hide();
}

PedidoController.prototype.ShowForm = function () {
    if (this.PedidoIndexForm) this.PedidoIndexForm.show();
}

PedidoController.prototype.InitializePedidoConfirmacion = function () {
}

PedidoController.prototype.ShowConfirmacion = function (orderId) {
    App.Layout.Dialog.Loading.Open();
    App.Pedido.UpdateConfirmacion(orderId, App.Pedido.ShowConfirmacionCallback);
}

PedidoController.prototype.ShowConfirmacionCallback = function (res, data) {
    if (res) {
        App.Layout.Dialog.Loading.Close(function () {
            $.mobile.changePage("#PedidoConfirmacion");
        });
    }
}

PedidoController.prototype.UpdateConfirmacion = function (orderId, callback) {
    Utils.GetData("Mobile/Pedido/Confirmacion", { ID: orderId }, function (res, data) {
        if (res) {
            App.Pedido.CurrentOrderID = data.DisplayNumber;
            App.Pedido.CurrentOrder = data;
            Utils.DataBind(data, "PedidoConfirmacionInfo", false, false);
            Utils.DataBind(data, "PedidoConfirmacionOrder", false, false);
            App.Pedido.UpdateMessage(data, false);
            App.Pedido.MonitorStatus(data);
        }
        if (callback) callback(res, data);
    });
}

PedidoController.prototype.MonitorStatus = function (data) {
    if (data) {
        if (data.IsAccepted || data.IsRejected) return;
    }
    window.setTimeout(function () {
        if (!App.Pedido.CurrentOrderID) return;
        //if ($.mobile.activePage.attr("id") != "PedidoConfirmacion") return;
        Utils.PostData("Mobile/Pedido/GetOrderStatus", { ID: App.Pedido.CurrentOrderID }, function (res, data) {
            if (res) {
                if (data.IsAccepted) App.Pedido.UpdateMessage({ IsAccepted: true, IsRejected: false, AcceptedNotes: data.StatusMessage }, true);
                if (data.IsRejected) App.Pedido.UpdateMessage({ IsAccepted: false, IsRejected: true, RejectedNotes: data.StatusMessage }, true);
                if (data.IsAccepted || data.IsRejected) {
                    App.Authentication.UpdateCurrentNotificationsCount();
                    return;
                }
            }
            App.Pedido.MonitorStatus();
        }, true);
    }, 30000);
}

PedidoController.prototype.UpdateMessage = function (data, animate) {
    var p = $("#PedidoConfirmacionMsgP");
    var a = $("#PedidoConfirmacionMsgA");
    var r = $("#PedidoConfirmacionMsgR");
    if (animate) {
        p.slideUp(); a.slideUp(); r.slideUp();
    }
    else {
        p.hide(); a.hide(); r.hide();
    }
    if (data.IsAccepted) {
        if (data.AcceptedNotes && data.AcceptedNotes != "") {
            $("#PedidoConfirmacionMsgAtxt span").text(data.AcceptedNotes);
        }
        else {
            $("#PedidoConfirmacionMsgAtxt").hide();
        }
        if (animate) {
            a.slideDown();
        } else {
            a.show();
        }
        return;
    }
    if (data.IsRejected) {
        if (data.RejectedNotes && data.RejectedNotes != "") {
            $("#PedidoConfirmacionMsgRtxt span").text(data.RejectedNotes);
        }
        else {
            $("#PedidoConfirmacionMsgRtxt").hide();
        }
        if (animate) {
            r.slideDown();
        } else {
            r.show();
        }
        return;
    }
    p.show();
}