﻿function UsuarioController() {
    BaseController.call(this, "Usuario");
    this.ReturnToOrder = false;
    this.CurrentPedido = null;
    this.CurrentDireccion = null;
    this.CurrentDireccionReturn = null;
    this.IsRegistration = false;
}

UsuarioController.prototype = Object.create(BaseController.prototype);
UsuarioController.prototype.constructor = UsuarioController;
App.RegisterController(UsuarioController);

UsuarioController.prototype.Initialize = function (callback) {
    App.RegisterPageInitializer("UsuarioIngresar", this.InitializeUsuarioIngresar);
    App.RegisterPageInitializer("UsuarioRegistracion", this.InitializeUsuarioRegistracion);
    App.RegisterPageInitializer("UsuarioDireccion", this.InitializeUsuarioDireccion);
    App.RegisterPageInitializer("UsuarioPedidos", this.InitializeUsuarioPedidos);
    App.RegisterPageInitializer("UsuarioPedido", this.InitializeUsuarioPedido);
    App.RegisterPageInitializer("UsuarioIndex", this.InitializeUsuarioIndex);
    App.RegisterPageInitializer("UsuarioNotificaciones", this.InitializeUsuarioNotificaciones);
    App.RegisterPageInitializer("UsuarioChangePassword", this.InitializeUsuarioChangePassword);
    App.RegisterPageInitializer("UsuarioRecuperar", this.InitializeUsuarioRecuperar);
    BaseController.prototype.Initialize.call(this, callback);
}

UsuarioController.prototype.InitializeUsuarioIngresar = function () {
    App.Usuario.ResetUsuarioIngresar();
    $("#UsuarioIngresarLogin").click(function () {
        App.Usuario.Ingresar();
        return false;
    });
    $("#UsuarioIngresarLoginFB").click(function () {
        App.Usuario.IngresarFB();
        return false;
    });
    $("#UsuarioIngresarRegister").click(function () {
        App.Usuario.ShowRegistracion(App.Usuario.ReturnToOrder);
        return false;
    });
    $("#UsuarioIngresarForgot").click(function () {
        App.Usuario.ShowRecuperar();
        return false;
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioIngresar", App.Usuario.Ingresar);
}

UsuarioController.prototype.ResetUsuarioIngresar = function () {
    $("#UsuarioIngresarLoginUser").val("");
    $("#UsuarioIngresarLoginPass").val("");
}

UsuarioController.prototype.ShowIngresar = function (returnToOrder) {
    this.ResetUsuarioIngresar();
    this.ReturnToOrder = false;
    if (returnToOrder) this.ReturnToOrder = true;
    $.mobile.changePage("#UsuarioIngresar");
}

UsuarioController.prototype.Ingresar = function () {
    var user = $("#UsuarioIngresarLoginUser").val();
    var pass = $("#UsuarioIngresarLoginPass").val();
    if (!user || user == "" || !pass || pass == "") {
        App.Layout.Dialog.Alert.Open("Error", "Completá tu dirección de email y contraseña para ingresar");
        return;
    }
    if (user.match(/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z0-9.-]+$/i) == null) {
        App.Layout.Dialog.Alert.Open("Error", "Ingresá una dirección de email válida");
        return;
    }
    App.Layout.Dialog.Loading.Open();
    App.Authentication.LogIn(user, pass, true, App.Usuario.IngresarCallback);
}

UsuarioController.prototype.IngresarFB = function () {
    App.Layout.Dialog.Loading.Open();
    App.Authentication.LogInFB(App.Usuario.IngresarCallback);    
}

UsuarioController.prototype.IngresarCallback = function (res, data) {
    if (res) {
        App.Layout.Dialog.Loading.Close(function () {
            if (res && data && data.Success) {
                if (App.Authentication.Current.IsAuthenticated) {
                    App.Layout.ShowToast("Se inició sesión de usuario.<br />Bienvenido, " + App.Authentication.Current.UserName + ".");
                    if (App.Usuario.ReturnToOrder) {
                        App.Pedido.ShowIndex();
                    } else {
                        App.Home.Show();
                    }
                }
                else {
                    if (App.Authentication.Current.FacebookAuthenticationInfo.IsFacebookAuthenticated) {
                        if (!App.Authentication.Current.FacebookAuthenticationInfo.IsRegistered) {
                            App.Usuario.ShowRegistracion(App.Usuario.ReturnToOrder);
                        }
                    }
                }
            }
            else {
                if (res && data) App.Layout.Dialog.Alert.Open("Error", data.ErrorMessage);
            }
        });
    }
}

UsuarioController.prototype.InitializeUsuarioRegistracion = function () {
    App.Usuario.ResetUsuarioRegistracion();
    $("#UsuarioRegistracionContinue").click(function () {
        App.Usuario.ValidateInfo();
        return false;
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioRegistracion", App.Usuario.ValidateInfo);
}

UsuarioController.prototype.ResetUsuarioRegistracion = function () {
    $("#UsuarioRegistracionEmail").val("");
    $("#UsuarioRegistracionPassword").val("");
    $("#UsuarioRegistracionPassword2").val("");
    $("#UsuarioRegistracionFirstName").val("");
    $("#UsuarioRegistracionLastName").val("");
    $("#UsuarioRegistracionCell").val("");
    Utils.UI.Checkbox.Uncheck($("#UsuarioRegistracionTerms"));
    var fbinfo = App.Authentication.Current.FacebookAuthenticationInfo;
    if (fbinfo && fbinfo.IsFacebookAuthenticated && !fbinfo.IsRegistered) {
        $("#UsuarioRegistracionCredentialsCont").hide();
        $("#UsuarioRegistracionFBCont").show();
        var fullname = fbinfo.FirstName + " " + fbinfo.LastName;
        $("#UsuarioRegistracionFBPicture").attr("src", fbinfo.PictureURL).attr("alt", fullname);
        $("#UsuarioRegistracionFBName").text(fullname);
        if (fbinfo.IsValidEmail) {
            $("#UsuarioRegistracionFBEmail").text(fbinfo.Email);
            $("#UsuarioRegistracionEmail").val(fbinfo.Email);
        }
        else {
            $("#UsuarioRegistracionFBEmail").text("");
            $("#UsuarioRegistracionEmail").val("");
        }
        $("#UsuarioRegistracionFirstName").val(fbinfo.FirstName);
        $("#UsuarioRegistracionLastName").val(fbinfo.LastName);
        $("#UsuarioRegistracionPassword").val("********");
        $("#UsuarioRegistracionPassword2").val("********");
    }
    else {
        $("#UsuarioRegistracionCredentialsCont").show();
        $("#UsuarioRegistracionFBCont").hide();
    }
}

UsuarioController.prototype.ShowRegistracion = function (returnToOrder) {
    this.ResetUsuarioRegistracion();
    this.ReturnToOrder = false;
    if (returnToOrder) this.ReturnToOrder = true;
    this.GoToRegistracion();
}

UsuarioController.prototype.GoToRegistracion = function () {
    $.mobile.changePage("#UsuarioRegistracion");
}

UsuarioController.prototype.ValidateInfo = function () {
    var email = $("#UsuarioRegistracionEmail").val();
    var pass = $("#UsuarioRegistracionPassword").val();
    var pass2 = $("#UsuarioRegistracionPassword2").val();
    var firstname = $("#UsuarioRegistracionFirstName").val();
    var lastname = $("#UsuarioRegistracionLastName").val();
    var cell = $("#UsuarioRegistracionCell").val();
    var hasCell = (cell != null && cell != "");
    var terms = $("#UsuarioRegistracionTerms").is(":checked");
    var news = true;
    if (!email || email == "" || !pass || pass == "" || !pass2 || pass2 == "" || !firstname || firstname == "" || !lastname || lastname == "") {
        App.Layout.Dialog.Alert.Open("Error", "Completá todos los campos requeridos para continuar");
        return;
    }
    if (email.match(/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z0-9.-]+$/i) == null) {
        App.Layout.Dialog.Alert.Open("Error", "Ingresá una dirección de email válida");
        return;
    }
    if (pass.length < 8) {
        App.Layout.Dialog.Alert.Open("Error", "La contraseña debe tener al menos 8 caracteres");
        return;
    }
    if (pass != pass2) {
        App.Layout.Dialog.Alert.Open("Error", "La contraseña y su confirmación no coinciden");
        return;
    }
    if (!terms) {
        App.Layout.Dialog.Alert.Open("Error", "Debés aceptar los términos y condiciones para registrarte");
        return;
    }
    App.Usuario.ShowDireccionRegistracion(hasCell);
}

UsuarioController.prototype.InitializeUsuarioDireccion = function () {
    $("#UsuarioDireccion").on("pageshow", function () {
        BaseController.prototype.RefreshFormData.call(App.Usuario, "UsuarioDireccion", App.Usuario.ExecuteUsuarioDireccion, true);
    });
    $("#UsuarioDireccionUseCell").on("change", function () {
        App.Usuario.ToggleDireccionUseCell();
    });
    $("#UsuarioDireccionGo").click(function () {
        App.Usuario.ExecuteUsuarioDireccion();
        return false;
    });
    $("#UsuarioDireccionCancel").click(function () {
        App.Usuario.CancelAddress();
        return false;
    });
    $("#UsuarioDireccionGoReg").click(function () {
        App.Usuario.ExecuteUsuarioDireccion();
        return false;
    });
    $("#UsuarioDireccionCancelReg").click(function () {
        App.Usuario.GoToRegistracion();
        return false;
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioDireccion", App.Usuario.ExecuteUsuarioDireccion);
}

UsuarioController.prototype.ExecuteUsuarioDireccion = function () {
    if (App.Usuario.IsRegistration) {
        App.Usuario.Register();
    }
    else {
        App.Usuario.SaveAddress();
    }
}

UsuarioController.prototype.ResetUsuarioDireccion = function (isRegistration, hasCell) {
    this.IsRegistration = isRegistration;
    Utils.DataBind(App.Layout.General.City, "UsuarioDireccionCity", true);
    $("#UsuarioDireccionAddress").val("");
    $("#UsuarioDireccionFloor").val("");
    $("#UsuarioDireccionAppt").val("");
    $("#UsuarioDireccionPhone").val("");
    $("#UsuarioDireccionName").val("");
    $("#UsuarioDireccionNotes").val("");
    Utils.UI.Checkbox.Uncheck($("#UsuarioDireccionUseCell"));
    $("#UsuarioDireccionPhoneCont").show();
    $("#UsuarioDireccionUseCellCont").show();
    if (isRegistration) {
        $("#UsuarioDireccionActions").hide();
        $("#UsuarioDireccionActionsReg").show();
        if (!hasCell) $("#UsuarioDireccionUseCellCont").hide();
    }
    else {
        $("#UsuarioDireccionActions").show();
        $("#UsuarioDireccionActionsReg").hide();
    }
}

UsuarioController.prototype.ShowDireccion = function (id, returnCallBack) {
    App.Layout.Dialog.Loading.Open();
    this.ResetUsuarioDireccion(false);
    Utils.GetData("Mobile/Usuario/Direccion", { ID: id }, function (res, data) {
        if (res) {
            App.Usuario.CurrentDireccion = data;
            App.Usuario.CurrentDireccionReturn = returnCallBack;
            if (!data.UserHasCellPhone) $("#UsuarioDireccionUseCellCont").hide();
            if (id && data.AddressDialogID) {
                $("#UsuarioDireccionCity").val(data.AddressDialogCityID).change();
                $("#UsuarioDireccionAddress").val(data.AddressDialogAddressStreet);
                $("#UsuarioDireccionFloor").val(data.AddressDialogFloor);
                $("#UsuarioDireccionAppt").val(data.AddressDialogAppartment);
                $("#UsuarioDireccionPhone").val(data.AddressDialogPhone);
                $("#UsuarioDireccionName").val(data.AddressDialogName);
                $("#UsuarioDireccionNotes").val(data.AddressDialogNotes);
                if (data.AddressDialogUseCellPhone) {
                    Utils.UI.Checkbox.Check($("#UsuarioDireccionUseCell"));
                    $("#UsuarioDireccionPhoneCont").hide();
                }
            }
            App.Layout.Dialog.Loading.Close(function () {
                $.mobile.changePage("#UsuarioDireccion");
            });
        }
    });
}

UsuarioController.prototype.SaveAddress = function () {
    var city = $("#UsuarioDireccionCity").val();
    var cityName = $("#UsuarioDireccionCity option:selected").text();
    var address = $("#UsuarioDireccionAddress").val();
    var floor = $("#UsuarioDireccionFloor").val();
    var appt = $("#UsuarioDireccionAppt").val();
    var phone = $("#UsuarioDireccionPhone").val();
    var name = $("#UsuarioDireccionName").val();
    var notes = $("#UsuarioDireccionNotes").val();
    var useCell = $("#UsuarioDireccionUseCell").is(":checked");
    if (!city || city == "" || !address || address == "" || !name || name == "" || (!useCell && !phone) || (!useCell && phone == "")) {
        App.Layout.Dialog.Alert.Open("Error", "Completá todos los campos requeridos para continuar");
        return;
    }
    App.Layout.Dialog.Loading.Open();
    var pdata = {
        AddressDialogCityID: city,
        AddressDialogAddressStreet: address,
        AddressDialogFloor: floor,
        AddressDialogAppartment: appt,
        AddressDialogPhone: phone,
        AddressDialogUseCellPhone: useCell,
        AddressDialogNotes: notes,
        AddressDialogName: name,
        AddressDialogID: (this.CurrentDireccion ? this.CurrentDireccion.AddressDialogID : null)
    };
    Utils.GeocodeLocation(cityName, address, function (result, items) {
        if (result) {
            Utils.PostData("Mobile/Usuario/Direccion", pdata, function (res, data) {
                if (res && data && data.Success) {
                    App.Authentication.UpdateCurrent(function () {
                        App.Layout.Dialog.Loading.Close(function () {
                            App.Layout.ShowToast("Ubicación actualizada correctamente.");
                            App.Usuario.CurrentDireccionReturn(res, data);
                        });
                    });
                }
            });
        }
        else {
            App.Layout.Dialog.Loading.Close(function () {
                App.Layout.Dialog.Alert.Open("Error", "No se pudo localizar la ubicación, verificá el nombre de la calle y la altura");
            });
        }
    });
}

UsuarioController.prototype.CancelAddress = function () {
    this.CurrentDireccionReturn();
}

UsuarioController.prototype.ShowDireccionRegistracion = function (hasCell) {
    this.ResetUsuarioDireccion(true, hasCell);
    $.mobile.changePage("#UsuarioDireccion");
}

UsuarioController.prototype.ToggleDireccionUseCell = function () {
    var useCell = $("#UsuarioDireccionUseCell").is(":checked");
    $("#UsuarioDireccionPhone").val("");
    if (useCell) {
        $("#UsuarioDireccionPhoneCont").fadeOut(function () {
            BaseController.prototype.RefreshFormData.call(App.Usuario, "UsuarioDireccion", App.Usuario.ExecuteUsuarioDireccion, true);
        });
    }
    else {
        $("#UsuarioDireccionPhoneCont").fadeIn(function () {
            BaseController.prototype.RefreshFormData.call(App.Usuario, "UsuarioDireccion", App.Usuario.ExecuteUsuarioDireccion, true);
        });
    }
}

UsuarioController.prototype.Register = function () {
    var city = $("#UsuarioDireccionCity").val();
    var cityName = $("#UsuarioDireccionCity option:selected").text();
    var address = $("#UsuarioDireccionAddress").val();
    var floor = $("#UsuarioDireccionFloor").val();
    var appt = $("#UsuarioDireccionAppt").val();
    var phone = $("#UsuarioDireccionPhone").val();
    var name = $("#UsuarioDireccionName").val();
    var notes = $("#UsuarioDireccionNotes").val();
    var useCell = $("#UsuarioDireccionUseCell").is(":checked");
    if (!city || city == "" || !address || address == "" || !name || name == "" || (!useCell && !phone) || (!useCell && phone == "")) {
        App.Layout.Dialog.Alert.Open("Error", "Completá todos los campos requeridos para continuar");
        return;
    }
    App.Layout.Dialog.Loading.Open();
    var email = $("#UsuarioRegistracionEmail").val();
    var pass = $("#UsuarioRegistracionPassword").val();
    var pass2 = $("#UsuarioRegistracionPassword2").val();
    var firstname = $("#UsuarioRegistracionFirstName").val();
    var lastname = $("#UsuarioRegistracionLastName").val();
    var cell = $("#UsuarioRegistracionCell").val();
    var hasCell = (cell != null && cell != "");
    var terms = $("#UsuarioRegistracionTerms").is(":checked");
    var news = true;
    var regdata = {
        Email: email,
        Password: pass,
        ConfirmPassword: pass2,
        FirstName: firstname,
        LastName: lastname,
        CellPhone: cell,
        HasAcceptedContract: terms,
        HasAcceptedNewsletter: news,
        AddressName: name,
        AddressCityID: city,
        AddressStreet: address,
        AddressFloor: floor,
        AddressAppartment: appt,
        AddressPhone: phone,
        AddressUseCellPhone: useCell,
        AddressNotes: notes
    };
    Utils.GeocodeLocation(cityName, address, function (result, items) {
        if (result) {
            Utils.PostData("Mobile/Usuario/Registracion", regdata, function (res, data) {
                if (res && data) {
                    if (data.Errors.length > 0) {
                        App.Layout.Dialog.Loading.Close(function () {
                            App.Layout.Dialog.Alert.Open("Error", data.Errors);
                        });
                        return;
                    }
                    if (data.Success) {
                        App.Authentication.UpdateCurrent(function (res, data) {
                            if (res) {
                                App.Layout.Dialog.Loading.Close(function () {
                                    if (res && App.Authentication.Current.IsAuthenticated) {
                                        App.Layout.ShowToast("Registración completa.<br />Bienvenido a Relivery, " + App.Authentication.Current.UserName + ".");
                                    }
                                    if (App.Usuario.ReturnToOrder) {
                                        App.Pedido.ShowIndex();
                                    } else {
                                        App.Home.Show();
                                    }
                                });
                            }
                            else {
                                App.Home.Show();
                            }
                        });
                    }
                }
            });
        }
        else {
            App.Layout.Dialog.Loading.Close(function () {
                App.Layout.Dialog.Alert.Open("Error", "No se pudo localizar la ubicación, verificá el nombre de la calle y la altura");
            });
        }
    });
}

UsuarioController.prototype.InitializeUsuarioPedidos = function () {
    $("#UsuarioPedidosList").on("click", ".item", function () {
        var id = $(this).data("id");
        App.Usuario.SetCurrentPedido(id);
    });
}

UsuarioController.prototype.LoadPedidos = function () {
    App.Layout.Dialog.Loading.Open();
    Utils.PostData("Mobile/Usuario/Pedidos", null, function (res, data) {
        if (res) {
            for (var ii = 0; ii < data.length; ii++) {
                data[ii].StorePicture = Utils.GetPath(data[ii].StorePicture);
                if (data[ii].HasRanking) {
                    for (var i = 0; i < 5; i++) {
                        data[ii]["Ranking" + (i + 1)] = (data[ii].RankingAverage >= (i * 2) + 2) ? "fa-star" : ((data[ii].RankingAverage >= (i * 2) + 1) ? "fa-star-half-o" : "fa-star-o");
                    }
                }
            }
            Utils.DataBind(data, "UsuarioPedidosList", false, false);
            App.Layout.Dialog.Loading.Close(function () {
                App.Usuario.ShowPedidos();
            });
        }
    });
}

UsuarioController.prototype.ShowPedidos = function () {
    $.mobile.changePage("#UsuarioPedidos");
}

UsuarioController.prototype.InitializeUsuarioPedido = function () {
    $("#UsuarioPedidoBack").on("click", function () {
        App.Usuario.LoadPedidos();
    });
    $("#UsuarioPedidoRepeat").on("click", function () {
        App.Usuario.RepeatCurrentPedido();
    });
    $("#UsuarioPedidoRate").on("click", function () {
        App.Usuario.RatePedido();
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioPedido", App.Usuario.RatePedido);
}

UsuarioController.prototype.SetCurrentPedido = function (id) {
    App.Layout.Dialog.Loading.Open();
    Utils.PostData("Mobile/Usuario/Pedido", { ID: id }, function (res, data) {
        if (res) {
            App.Usuario.CurrentPedido = id;
            $("#UsuarioPedidoInfoTitle").text(data.DisplayNumber);
            if (data.HasRanking) {
                App.Usuario.ShowPedidoRanking(data.RankingAverage, false);
            } else {
                App.Usuario.ShowPedidoRankingForm(data.IsAccepted);
            }
            Utils.DataBind(data, "UsuarioPedidoInfo", false, false);
            Utils.DataBind(data, "UsuarioPedidoOrder", false, false);
            App.Layout.Dialog.Loading.Close(function () {
                App.Usuario.ShowPedido();
            });
        }
    });
}

UsuarioController.prototype.ShowPedido = function () {
    $.mobile.changePage("#UsuarioPedido");
}

UsuarioController.prototype.RepeatCurrentPedido = function () {
    App.Layout.Dialog.Loading.Open();
    Utils.PostData("Mobile/Usuario/RepetirPedido", { ID: this.CurrentPedido }, function (res, data) {
        if (res) {
            if (data.Success) {
                App.Layout.ShowToast("Se agregaron los productos a tu pedido actual.");
                App.Buscar.LoadItem(data.StoreID);
            }
            else {
                App.Layout.Dialog.Alert.Open("Error", "Se produjo un error al repetir el pedido");
            }
        }
    });
}

UsuarioController.prototype.ShowPedidoRanking = function (ranking, animate) {
    $("#UsuarioPedidoRankingCont").show();
    var stars = $("#UsuarioPedidoRankingShow .ranking i");
    if (stars.length == 5) {
        for (var i = 0; i < 5; i++) {
            $(stars[i]).attr("class", "fa " + ((ranking >= (i * 2) + 2) ? "fa-star" : ((ranking >= (i * 2) + 1) ? "fa-star-half-o" : "fa-star-o")));
        }
    }
    if (animate) {
        $("#UsuarioPedidoRankingForm").slideUp('slow', function () {
            $("#UsuarioPedidoRankingShow").slideDown('slow');
        });
    }
    else {
        $("#UsuarioPedidoRankingShow").show();
        $("#UsuarioPedidoRankingForm").hide();
    }
}

UsuarioController.prototype.ShowPedidoRankingForm = function (isAccepted) {
    if (!isAccepted) {
        $("#UsuarioPedidoRankingCont").hide();
        return;
    }
    $("#UsuarioPedidoRankingCont").show();
    $("#UsuarioPedidoRankingShow").hide();
    $("#UsuarioPedidoPrice").val("").change();
    $("#UsuarioPedidoQuality").val("").change();
    $("#UsuarioPedidoService").val("").change();
    $("#UsuarioPedidoRankingForm").show();
}

UsuarioController.prototype.RatePedido = function () {
    var p = $("#UsuarioPedidoPrice").val();
    var q = $("#UsuarioPedidoQuality").val();
    var s = $("#UsuarioPedidoService").val();
    if (!p || p == "" || !q || q == "" || !s || s == "") {
        App.Layout.Dialog.Alert.Open("Error", "Completá todos los campos requeridos para continuar");
        return;
    }
    App.Layout.Dialog.Loading.Open();
    Utils.PostData("Mobile/Usuario/PedidoRate", { orderid: App.Usuario.CurrentPedido, price: p, quality: q, speed: s }, function (res, data) {
        if (res) {
            if (data.Success) {
                App.Layout.Dialog.Loading.Close(function () {
                    App.Layout.ShowToast("Tu calificación fue guardada con éxito.", true);
                    App.Usuario.ShowPedidoRanking(data.RankingAverage, true);
                    App.Authentication.UpdateCurrentNotificationsCount();
                });
            }
            else {
                App.Layout.Dialog.Alert.Open("Error", "Se produjo un error al guardar la calificación");
            }
        }
    });
}

UsuarioController.prototype.InitializeUsuarioIndex = function () {
    $("#UsuarioIndex").on("pageshow", function () {
        BaseController.prototype.RefreshFormData.call(App.Usuario, "UsuarioIndex", App.Usuario.SaveProfile, true);
    });
    $("#UsuarioIndexForm").on("click", "#UsuarioIndexFormGo", function () {
        App.Usuario.SaveProfile();
    });
    $("#UsuarioIndexAddresses").on("click", "a", function () {
        var o = $(this);
        var id = o.data("id");
        var action = o.data("action");
        if (id && (id != "") && action && (action != "")) {
            if (action == "edit") {
                App.Usuario.ShowDireccion(id, function () {
                    App.Usuario.LoadProfile();
                });
            }
            if (action == "delete") App.Usuario.DeleteAddress(id);
        }
        return false;
    });
    $("#UsuarioIndexAddressGo").on("click", function () {
        App.Usuario.ShowDireccion(null, function () {
            App.Usuario.LoadProfile();
        });
        return false;
    });
    $("#UsuarioIndexChangePasswordGo").on("click", function () {
        App.Usuario.ShowChangePassword();
        return false;
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioIndex", App.Usuario.SaveProfile);
}

UsuarioController.prototype.LoadProfile = function (callback) {
    App.Layout.Dialog.Loading.Open();
    Utils.GetData("Mobile/Usuario/Index", null, function (res, data) {
        if (res) {
            Utils.DataBind(data, "UsuarioIndexForm", false, false);
            Utils.DataBind(data, "UsuarioIndexAddresses", false, false);
            Utils.UI.ListView.Refresh($("#UsuarioIndexAddresses"));
            if (data.IsFacebookAuthenticated) {
                $("#UsuarioIndexChangePasswordCont").hide();
            }
            else {
                $("#UsuarioIndexChangePasswordCont").show();
            }
            App.Layout.Dialog.Loading.Close(function () {
                App.Usuario.ShowProfile();
                if (callback) callback(res, data);
            });
        }
    });
}

UsuarioController.prototype.ShowProfile = function () {
    $.mobile.changePage("#UsuarioIndex");
}

UsuarioController.prototype.SaveProfile = function () {
    var fname = $("#UsuarioIndexFirstName").val();
    var lname = $("#UsuarioIndexLastName").val();
    var cellphone = $("#UsuarioIndexCellPhone").val();
    var bday = $("#UsuarioIndexBirthDateDay").val();
    var bmonth = $("#UsuarioIndexBirthDateMonth").val();
    var byear = $("#UsuarioIndexBirthDateYear").val();
    var how = $("#UsuarioIndexHowKnow").val();
    var sex = $("#UsuarioIndexSex").val();
    var marital = $("#UsuarioIndexMaritalStatus").val();
    var news = $("#UsuarioIndexHasNewsletter").is(":checked");
    if (!fname || fname == "" || !lname || lname == "") {
        App.Layout.Dialog.Alert.Open("Error", "Completá todos los campos requeridos para continuar");
        return;
    }
    App.Layout.Dialog.Loading.Open();
    var regdata = {
        FirstName: fname,
        LastName: lname,
        CellPhone: cellphone,
        BirthDateDay: bday,
        BirthDateMonth: bmonth,
        BirthDateYear: byear,
        SexValue: sex,
        HowKnow: how,
        MaritalStatusValue: marital,
        HasNewsletter: news
    };
    Utils.PostData("Mobile/Usuario/Index", regdata, function (res, data) {
        if (res && data) {
            if (data.Errors.length > 0) {
                App.Layout.Dialog.Loading.Close(function () {
                    App.Layout.Dialog.Alert.Open("Error", data.Errors);
                });
                return;
            }
            if (data.Success) {
                App.Layout.Dialog.Loading.Close(function () {
                    if (res && data && data.Success) {
                        App.Layout.ShowToast("Tu perfil fue actualizado correctamente.", true);
                        App.Authentication.UpdateCurrentNotificationsCount();
                    }
                    else {
                        if (res && data) App.Layout.Dialog.Alert.Open("Error", data.ErrorMessage);
                    }
                });
            }
        }
    });
}

UsuarioController.prototype.DeleteAddress = function (id) {
    App.Layout.Dialog.Loading.Open();
    Utils.PostData("Mobile/Usuario/DeleteAddress", { ID: id }, function (res, data) {
        if (res && data) {
            if (data.Success) {
                App.Authentication.UpdateCurrent(function () {
                    App.Usuario.LoadProfile(function () {
                        App.Layout.ShowToast("Ubicación eliminada correctamente.", true);
                    });
                });
            }
        }
    });
}

UsuarioController.prototype.InitializeUsuarioNotificaciones = function () {
    $("#UsuarioNotificacionesList").on("click", ".notif", function () {
        var a = $(this).data("action");
        if (a && (a != "")) {
            App.Layout.ExecuteUserAction(a);
        }
    });
}

UsuarioController.prototype.LoadAlerts = function () {
    App.Layout.Dialog.Loading.Open();
    Utils.GetData("Mobile/Usuario/Notificaciones", null, function (res, data) {
        if (res) {
            for (var i = 0; i < data.length; i++) { data[i].Number = i + 1; }
            Utils.DataBind(data, "UsuarioNotificacionesList", false, false);
            App.Layout.Dialog.Loading.Close(function () {
                App.Usuario.ShowAlerts();
                App.Authentication.UpdateCurrentNotificationsCount();
            });
        }
    });
}

UsuarioController.prototype.ShowAlerts = function () {
    $.mobile.changePage("#UsuarioNotificaciones");
}

UsuarioController.prototype.InitializeUsuarioChangePassword = function () {
    if (App.Authentication.Current.FacebookAuthenticationInfo && App.Authentication.Current.FacebookAuthenticationInfo.IsFacebookAuthenticated) {
        return false;
    }
    App.Usuario.ResetUsuarioChangePassword();
    $("#UsuarioChangePasswordGo").click(function () {
        App.Usuario.ChangePassword();
        return false;
    });
    $("#UsuarioChangePasswordCancel").click(function () {
        App.Usuario.ShowProfile();
        return false;
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioChangePassword", App.Usuario.ChangePassword);
}

UsuarioController.prototype.ResetUsuarioChangePassword = function () {
    $("#UsuarioChangePasswordCurrent").val("");
    $("#UsuarioChangePasswordNew").val("");
    $("#UsuarioChangePasswordNew2").val("");
}

UsuarioController.prototype.ShowChangePassword = function () {
    this.ResetUsuarioChangePassword();
    $.mobile.changePage("#UsuarioChangePassword");
}

UsuarioController.prototype.ChangePassword = function () {
    App.Layout.Dialog.Loading.Open();
    var cp = $("#UsuarioChangePasswordCurrent").val();
    var np = $("#UsuarioChangePasswordNew").val();
    var cnp = $("#UsuarioChangePasswordNew2").val();
    var cdata = {
        cp: cp,
        np: np,
        cnp: cnp
    };
    Utils.PostData("Mobile/Usuario/ChangePassword", cdata, function (res, data) {
        if (res && data) {
            App.Layout.Dialog.Loading.Close(function () {
                if (res && data && data.Success) {
                    App.Layout.ShowToast("Contraseña actualizada correctamente.");
                    App.Usuario.ShowProfile();
                }
                else {
                    if (res && data) App.Layout.Dialog.Alert.Open("Error", data.ErrorMessage);
                }
            });
        }
    });
}

UsuarioController.prototype.InitializeUsuarioRecuperar = function () {
    App.Usuario.ResetUsuarioRecuperar();
    $("#UsuarioRecuperarGo").click(function () {
        App.Usuario.ForgotPassword();
        return false;
    });
    $("#UsuarioRecuperarCancel").click(function () {
        App.Usuario.ShowIngresar(App.Usuario.ReturnToOrder);
        return false;
    });
    BaseController.prototype.InitializeForm.call(App.Usuario, "UsuarioRecuperar", App.Usuario.ForgotPassword);
}

UsuarioController.prototype.ResetUsuarioRecuperar = function () {
    $("#UsuarioRecuperarEmail").val("");
}

UsuarioController.prototype.ShowRecuperar = function () {
    this.ResetUsuarioRecuperar();
    $.mobile.changePage("#UsuarioRecuperar");
}

UsuarioController.prototype.ForgotPassword = function () {
    var email = $("#UsuarioRecuperarEmail").val();
    if (!email || email == "") {
        App.Layout.Dialog.Alert.Open("Error", "Completá tu dirección de email para continuar");
        return;
    }
    if (email.match(/^[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z0-9.-]+$/i) == null) {
        App.Layout.Dialog.Alert.Open("Error", "Ingresá una dirección de email válida");
        return;
    }
    App.Layout.Dialog.Loading.Open();
    Utils.PostData("Mobile/Usuario/Recuperar", { mail: email }, function (res, data) {
        if (res && data) {
            App.Layout.Dialog.Loading.Close(function () {
                if (res && data && data.Success) {
                    App.Layout.ShowToast("Contraseña enviada correctamente.");
                    App.Usuario.ShowIngresar(App.Usuario.ReturnToOrder);
                }
                else {
                    if (res && data) App.Layout.Dialog.Alert.Open("Error", data.ErrorMessage);
                }
            });
        }
    });
}